#include <iostream>
#include <stack>
#include <vector>
using namespace std;

const int MAXN = 1e5 + 10, MAXQ = 1e5 + 10;

int d[MAXN], distant[MAXN], s[MAXN];
int ptr[MAXN], speed[MAXN];
int reached_stop[MAXN], soonest[MAXN][3];
int total_distant_using_ptr[MAXN];

long double suffix[MAXN][3];

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, l, barrier = 0;
    cin >> n >> l;

    vector <int> speed_stack;
    speed[0] = 120;

    for (int i = 1; i <= n; i++) {
        cin >> d[i] >> s[i];
        distant[i - 1] = d[i] - d[i - 1];
        total_distant_using_ptr[ptr[i - 1]] += distant[i - 1];

        if (s[i] != -1) {
            ptr[i] = (++barrier);
            speed_stack.push_back(ptr[i]);
            speed[ptr[i]] = s[i];
        } else {
            if (speed_stack.empty()) reached_stop[i] = -1;
            else speed_stack.pop_back();

            if (!speed_stack.empty()) ptr[i] = speed_stack.back();
            else ptr[i] = 0;

            //cout << i << " : " << ptr[i] << endl;

            //if (speed_stack.size() == 1) reached_stop[i] = 1;
        }

    }


    distant[n] = l - d[n];
    ptr[n + 1] = 0;
    //for (int i = 0; i <= n; i++) cout << i << " : " << distant[i] << ' ' << speed[ptr[i]] << ' ' << ((long double) distant[i]) / ((long double) speed[ptr[i]]) << '\n';

    for (int j = 1; j < 2; j++) {
        for (int i = n; i >= 0; i--) {
            long double amt = ((long double) distant[i]) / ((long double) speed[ptr[max(0, i + 2 * (j - 1))]]);
            suffix[i][j] = suffix[i + 1][j] + amt;
            //cout << suffix[i][j] << endl;
        }

        soonest[n + 1][j] = n + 1;

        for (int i = n; i >= 1; i--) {
            if (reached_stop[i] == j - 1) soonest[i][j] = i;
            else soonest[i][j] = soonest[i + 1][j];
        }
    }

    long double total = suffix[0][1];

    //cout << total << endl;

    int q;
    cin >> q;

    for (int i = 1; i <= q; i++) {
        int p, ss;
        cin >> p >> ss;

        long double ans = suffix[0][1] - suffix[p][1];

        if (s[p] == ss) {
            cout << total << '\n';
        } else if (min(s[p], ss) > 0) {
            long double dist = total_distant_using_ptr[ptr[i]];
            long double diff = dist / ss - dist / s[p];

            cout << total + diff << '\n';
        } else if (ss == -1) {
            exit(1);
        }
    }
    return 0;

}
